# Oppgave 1
# list comprehension: from a list of names, build a list that contains: (1) the name spelled in reverse, and (2) its length

names = ['Jakob', 'Emma', 'Ola', 'Sondre', 'Maia', 'Emilie', 'Noa']

new = [[name[::-1],len(name)] for name in names]

print(new)


# Oppgave 2
# map(funtion,list)
names = ['Jakob', 'Emma', 'Ola', 'Sondre', 'Maia', 'Emilie', 'Noa']

def flip(item):
    return [item[::-1], len(item)]

new = list(map(flip, names))

print(new)


# Oppgave 3
# tuple packing/unpacking 
cat = ('aloof', 'meow', 'tuna')
dog = ('friendly', 'woof', 'sausage')

# one way 
personality, voice, fav_food = zip(cat,dog)
print(list(personality))

# another way 
list(cat)
list(dog)

personality_list= []
personality_list.append(cat[0])
personality_list.append(dog[0])
print(personality_list)


# Oppgave 4
# original tuple 
cat = ('aloof', 'meow', 'tuna')

# convert to a list 
cat_list = list(cat)

# swap item 
cat_list[2] = 'laks'

 
# flip back to tuple and print 
print(tuple(cat_list))


# Oppgave 5
#last in, first out

stack = [3,4,5]

#add to stack
stack.append(6)
stack.append(7)
# can have a print statement here to check your additions

#remove from stack 
stack.pop()
stack.pop()
stack.pop()
print(stack)


# Oppgave 6
word_list = []

def pigify(word):
    vowels = ['a','e','i','o','u']

    if word[0] in vowels:
        word += 'way'
        return word
    else:
        for letter in word:
            if letter in vowels:
                index_pos = word.index(letter) #find index pos of first vowel in the word 
                return word[index_pos:] + word[:index_pos]+'ay'
    
    
# create list of words from user input
while True:
    # print('Enter word ' + str(len(word_list) + 1) +
    #   ' (Or enter nothing to stop.):')
    word = input("Enter word: ")
    if word == '':
        break
    word_list += [word]  # list concatenation

print()
print('original words:')
print(word_list)

print('words in pig latin:')
print(list(map(pigify,word_list)))


# Oppgave 7
#sorted() with keyword arguments

frukt = ['eple', 'appelsin', 'ananas', 'kokosnøtt', 'banan', 'kirsebær']

print(sorted(frukt, key=len))
# Oppgave 8
def return_change(payment, price):
    coins = [20, 10, 5, 1]
    difference = payment - price
    change = []

    for coin in coins:
        while difference >= coin:
            change += [coin]
            difference -= coin
    return change

